/******************************************************
IAR_2.10+STM8S_StdPeriph_Lib_V2.1.0
Chip type: STM8S003K3 16MHz
Project: freeser control v2 
******************************************************/
#include "stm8s.h"
#include "iostm003.c"
#include <stdbool.h>


#define scr_on    do{PC_ODR=0xff;}while(0)
#define scr_off   do{GPIOC->ODR=0;}while(0)

#define rel_on    GPIOE->ODR = 1<<5;
#define rel_off   GPIOE->ODR = ~(1<<5);

#define tmrnmbr 1
#define timnmbr 1

bool adc3_ready=0; //for calculation 
bool adc_wok=0; //for iwdg
u8 adc3;

void gpio_cfg()
{
  PA_ODR = 0;     PA_CR1=1<<2|1<<1;    PA_DDR = 0;
  PB_ODR = 1<<5;  PB_CR1=0;            PB_DDR = 0;
  PC_ODR = 0xff;  PC_CR1=0xff;         PC_DDR = 1<<4|1<<3|1<<2|1<<1;
  PD_ODR = 0;     PD_CR1=0;            PD_DDR = 0;
  PE_ODR = 0;     PE_CR1=0xff;         PE_DDR = 1<<5;

}
void clk_cfg()
{
  CLK_DeInit();
  CLK->CKDIVR = 0;     //16MHz
  CLK->PCKENR1 = CLK_PCKENR1_TIM1;
}

void t1_cfg()
{

  TIM1->PSCRH  = 0xff;
  TIM1->PSCRL  = 0xff; //244 Hz
  TIM1->ARRH   = 0;
  TIM1->ARRL   = 0xf3/4; //4 Hz out
  TIM1->EGR    = TIM1_EGR_UG;
  TIM1->IER    = TIM1_IER_UIE;
  TIM1->CR1   |= TIM1_CR1_CEN;
}

void adc_cfg()
{
  ADC1->CR1  = ADC1_PRESSEL_FCPU_D18;
  ADC1->CR2  = ADC1_ALIGN_LEFT;
  ADC1->CSR  = 3; 
  ADC1->TDRL = 1<<3;

  ADC1->CR1 |= ADC1_CR1_ADON;
}

void iwdg_cfg()
{
IWDG->KR = IWDG_WriteAccess_Enable;
IWDG->PR = IWDG_Prescaler_256;
IWDG->RLR = 0xff; //1s   
IWDG->KR = IWDG_KEY_ENABLE;
IWDG->KR = IWDG_KEY_REFRESH;
}

void get_adc();


INTERRUPT_HANDLER(TIM1_UPD_OVF_TRG_BRK_IRQHandler, 11)
{
 static u16 timerval=0;
 static u16 ctimeval;
 static bool o_trg;
 
#define timer_criteria (30*60*4) // 
 
 if(timerval<timer_criteria)timerval++;
 else {timerval=0; o_trg=0;}
 
 if(adc3_ready)
  {
   adc3_ready=0;
   if(adc3>0xff/6)
   {
    ctimeval=((u32)(timer_criteria-timer_criteria/12)*adc3)>>8;
    if(ctimeval<timer_criteria/6)ctimeval = timer_criteria/6;
	  rel_on;
   }
	 else {ctimeval=0;rel_off;}
  }
 

 if(timerval<(timer_criteria)/12) {scr_off;}
 else if(timerval<ctimeval) {if(!o_trg)scr_on;}
 else {if(!o_trg){o_trg=1;scr_off;}}
 
 
  
  
// for(u8 i=0; i<timnmbr;i++) if(tim[i])tim[i]--;
// for(u8 i=0;i<tmrnmbr;i++) if(tmr[i])tmr[i]--; 
 
  if(adc_wok&&timerval<timer_criteria+1&&ctimeval<timer_criteria+1-(timer_criteria)/12&&(PC_DDR&(1<<4|1<<3|1<<2|1<<1)))
  { 
  IWDG->KR = IWDG_KEY_REFRESH;
  adc_wok=0;
  } 
 
 TIM1->SR1 &= ~TIM1_SR1_UIF;
}





main()
{
gpio_cfg();
clk_cfg();
adc_cfg();
t1_cfg();

ADC1->CR1 |= ADC1_CR1_ADON;

asm("rim");

iwdg_cfg();


  while(1)
  {
    get_adc();

    
 

  }
}


void get_adc()
{
  static u16 nacopitel=0;
  static u8 schetchic=0;
  
  if(ADC1->CSR&ADC1_CSR_EOC)
  {  
    if(schetchic<0xff)
    {
      nacopitel += ADC1->DRH;
      schetchic ++;  
    }
    else 
    {
     adc3 = nacopitel>>8;
     nacopitel = 0;
     schetchic = 1;  
     adc3_ready = 1;
    }
    
    ADC1->CSR &= ~ADC1_CSR_EOC;   
    ADC1->CR1 |= ADC1_CR1_ADON;

    adc_wok=1;
  }
}

